#ifndef __MessageFormats__
#define __MessageFormats__
enum RequestType
{
    GET,
    PUT,
    DELETE,
    INVALIDATE
};


struct __attribute__ ((__packed__)) SalRequest
{
    uint32_t id;
    enum RequestType type;
    uint32_t keySize;
    uint32_t valueSize;
};

struct __attribute__ ((__packed__)) SalResponse
{
    //private:
    uint32_t  id;
    enum RequestType type;
    //public:
    uint32_t size;
};

struct __attribute__ ((__packed__)) InvRequest
{
    //private:
    uint32_t  id;
    enum RequestType type;
    //public:
    uint32_t keySize;
    
};


static uint32_t SUCCESS  = 0;
static uint32_t FAILURE = 1;

static int32_t SalRequestHeaderSize = sizeof(SalRequest);
static int32_t SalResponseSize = sizeof(SalResponse);
static uint32_t InvRequestHeaderSize = sizeof(InvRequest);
#endif