#ifndef __RdmaInvEndpoint__
#define __RdmaInvEndpoint__

#include <rdma/rdma_cma.h>
#include <rdma/rdma_verbs.h>
#include <stdint.h>
#include <errno.h>
#include <iostream>
#include <boost/lockfree/queue.hpp>
#include "RdmaEndpoint.hpp"
#include "MessageFormats.hpp"
#include <rocksdb/db.h>

class RdmaSalEndpoint : public RdmaEndpoint
{
public:

    rocksdb::DB *_db;
    RdmaSalEndpoint(struct rdma_cm_id *id, struct ibv_cq *completionQueue, int sendQueueSize,
                    int recvQueueSize, int sendMsgSize, int recvMsgSize,rocksdb::DB *_db);

    void processCqEvent(struct ibv_wc wc);
    void processSendCompletion(struct ibv_wc *data);
    void processRecvCompletion(struct ibv_wc *data);
    void processDelete(struct SalRequest *);
    void processGet(struct SalRequest *req);
    void processPut(struct SalRequest *req);
    int sendMessage(const char *buffer, uint32_t size);
    void close();
};
#endif