#include "RdmaReplicationEndpoint.hpp"

RdmaReplicationEndpoint::RdmaReplicationEndpoint(struct rdma_cm_id *id, struct ibv_cq *completionQueue, int sendQueueSize,
                                                 int recvQueueSize, int sendMsgSize, int recvMsgSize,rocksdb::DB *db)
    : RdmaEndpoint(id, completionQueue, sendQueueSize, recvQueueSize, sendMsgSize, recvMsgSize)
    ,_db(db)
{
}

void RdmaReplicationEndpoint::processSendCompletion(struct ibv_wc *data)
{
    std::cout << "send completion\n";
    _sendBuffers->push((void *)data->wr_id);
}
void RdmaReplicationEndpoint::processRecvCompletion(struct ibv_wc *data)
{
    std::cout << "recv completion\n";
    std::cout << "recieve" << (char *)(data->wr_id) << "\n";
    char* request = new char[data->byte_len];
    memcpy(request, (void *)data->wr_id,data->byte_len);
    rdma_post_recv(_cm_id, (void *)data->wr_id, (void *)data->wr_id, _recvMsgSize, _recvMr);
}

int RdmaReplicationEndpoint::sendMessage(const char *buffer, uint32_t size)
{
    if (size > _sendMsgSize)
        return -1;
    void* sendBuffer = nullptr;
    _sendBuffers->pop(sendBuffer);
    if (sendBuffer == nullptr)
        return -1;
    memcpy(sendBuffer, buffer, size);
    return rdma_post_send(_cm_id, sendBuffer, sendBuffer, size, _sendMr, 0);
}
